#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <delay.h>
#include <stdio.h>
#include <delay.h>



// 1 Wire Bus functions
#asm
   .equ __w1_port=0x12 ;PORTD
   .equ __w1_bit=4
#endasm
#include <1wire.h>

// DS1820 Temperature Sensor functions
#include <ds1820.h>


// I2C Bus functions
#asm
   .equ __i2c_port=0x12 ;PORTD
   .equ __sda_bit=0
   .equ __scl_bit=1
#endasm
#include <i2c.h>

// DS1307 Real Time Clock functions
#include <ds1307.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm
#include <lcd.h>


// Declare your global variables here
        char lcd_buf[16];
        char hour, min, sec;
        char date, month, year;
        int temp;


void lcd_output()
{

        lcd_clear();
        sprintf(lcd_buf, "%02u", hour);
        lcd_puts(lcd_buf);
        lcd_putsf(":");
        sprintf(lcd_buf, "%02u", min);
        lcd_puts(lcd_buf);
        lcd_putsf(":");
        sprintf(lcd_buf, "%02u", sec);
        lcd_puts(lcd_buf);
        lcd_gotoxy(0,1);
        if (temp>=0)
                {sprintf(lcd_buf, "%+i.%i", temp/10,temp%10);};
        if (temp<0)
                {sprintf(lcd_buf, "%+i.%i", temp/10,-temp%10);};

        lcd_puts(lcd_buf);

}


// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{

        rtc_get_time(&hour,&min,&sec);
        rtc_get_date(&date,&month,&year);
        lcd_output();

}


// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{

        temp=ds1820_temperature_10(0);
        lcd_output();

}


void main(void)
{
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000.000 kHz
TCCR0=0x02;
TCNT0=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;


// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: Off
GICR|=0x40;
MCUCR=0x02;
GIFR=0x40;


// I2C Bus initialization
i2c_init();

// DS1307 Real Time Clock initialization
rtc_init(0,1,0);

// LCD module initialization
lcd_init(16);

// 1 Wire Bus initialization
w1_init();

// Determine the number of DS1820 devices
// connected to the 1 Wire bus
//ds1820_devices=w1_search(0xf0,ds1820_rom_codes);

// Global enable interrupts
#asm("sei")

while (1)
      {

      };
}
